Package org.apache.sling.discovery.commons.providers.spi.base

# Class SyncTokenService

java.lang.Object
org.apache.sling.discovery.commons.providers.spi.base.AbstractServiceWithBackgroundCheck
org.apache.sling.discovery.commons.providers.spi.base.SyncTokenService

All Implemented Interfaces:
  `ClusterSyncService`

public class SyncTokenService extends AbstractServiceWithBackgroundCheck implements ClusterSyncService
Implements the syncToken idea: each instance stores a key-value pair with key=stringId and value=discoveryLiteSequenceNumber under /var/discovery/oak/syncTokens - and then waits until it sees the same token from all other instances in the cluster. This way, once the syncToken is received the local instance knows that all instances in the cluster are now in TOPOLOGY_CHANGING state (thus all topology-dependent activity is now stalled and waiting) and are aware of the new discoveryLite view.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected ClusterSyncHistory`
`clusterSyncHistory`
`protected DiscoveryLiteConfig`
`commonsConfig`
`protected org.apache.sling.api.resource.ResourceResolverFactory`
`resourceResolverFactory`
`protected org.apache.sling.settings.SlingSettingsService`
`settingsService`

### Fields inherited from class org.apache.sling.discovery.commons.providers.spi.base.AbstractServiceWithBackgroundCheck

`backgroundCheckRunnable, logger, slingId`

## Constructor Summary

Constructors
Constructor
Description
`SyncTokenService()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`activate()`
`void`
`cancelSync()`
`ClusterSyncHistory`
`getClusterSyncHistory()`
`protected org.apache.sling.api.resource.ResourceResolver`
`getResourceResolver()`
Get or create a ResourceResolver
`void`
`setConsistencyHistory(ClusterSyncHistory consistencyHistory)`
`void`
`sync(BaseTopologyView view, Runnable callback)`
Starts the synchronization process and calls the provided callback upon completion.
`protected void`
`syncToken(BaseTopologyView view, Runnable callback)`
`static SyncTokenService`
`testConstructor(DiscoveryLiteConfig commonsConfig, org.apache.sling.api.resource.ResourceResolverFactory resourceResolverFactory, org.apache.sling.settings.SlingSettingsService settingsService)`
`static SyncTokenService`
`testConstructorAndActivate(DiscoveryLiteConfig commonsConfig, org.apache.sling.api.resource.ResourceResolverFactory resourceResolverFactory, org.apache.sling.settings.SlingSettingsService settingsService)`

### Methods inherited from class org.apache.sling.discovery.commons.providers.spi.base.AbstractServiceWithBackgroundCheck

`cancelPreviousBackgroundCheck, startBackgroundCheck, triggerBackgroundCheck`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### commonsConfig

protected DiscoveryLiteConfig commonsConfig

### resourceResolverFactory

protected org.apache.sling.api.resource.ResourceResolverFactory resourceResolverFactory

### settingsService

protected org.apache.sling.settings.SlingSettingsService settingsService

### clusterSyncHistory

protected ClusterSyncHistory clusterSyncHistory

## Constructor Details

### SyncTokenService

public SyncTokenService()

## Method Details

### testConstructorAndActivate

public static SyncTokenService testConstructorAndActivate(DiscoveryLiteConfig commonsConfig, org.apache.sling.api.resource.ResourceResolverFactory resourceResolverFactory, org.apache.sling.settings.SlingSettingsService settingsService)

### testConstructor

public static SyncTokenService testConstructor(DiscoveryLiteConfig commonsConfig, org.apache.sling.api.resource.ResourceResolverFactory resourceResolverFactory, org.apache.sling.settings.SlingSettingsService settingsService)

### activate

protected void activate()

### setConsistencyHistory

public void setConsistencyHistory(ClusterSyncHistory consistencyHistory)

### getClusterSyncHistory

public ClusterSyncHistory getClusterSyncHistory()

### getResourceResolver

protected org.apache.sling.api.resource.ResourceResolver getResourceResolver() throws org.apache.sling.api.resource.LoginException
Get or create a ResourceResolver

Throws:
  `org.apache.sling.api.resource.LoginException`

### cancelSync

public void cancelSync()

Specified by:
  `cancelSync` in interface `ClusterSyncService`

### sync

public void sync(BaseTopologyView view, Runnable callback)
Description copied from interface: `ClusterSyncService`
Starts the synchronization process and calls the provided callback upon completion.

sync() is not thread-safe and should not be invoked concurrently.

If sync() gets called before a previous invocation finished, that previous invocation will be discarded, ie the callback of the previous invocation will no longer be called.

The synchronization process consists of making sure that the repository has processed any potential backlog of instances that are no longer part of the provided, new view. Plus it writes a 'sync-token' to a well-defined location, with all peers doing the same, and upon seeing all other sync-tokens declares successful completion - at which point it calls the callback.run().

Specified by:
  `sync` in interface `ClusterSyncService`
Parameters:
  `view` - the view which all instances in the local cluster should agree on having seen
  `callback` - the runnable which should be called after successful syncing

### syncToken

protected void syncToken(BaseTopologyView view, Runnable callback)